(* ::Package:: *)

BeginPackage["AssessExperiment`"]

Questions::usage = "placeholder: usage message to be written";
question1::usage = "placeholder: usage message to be written";
question1Supplementary1::usage = "placeholder: usage message to be written";
question1Supplementary2::usage = "placeholder: usage message to be written";
Grade::usage = "placeholder: usage message to be written";

GradeError::usage = "placeholder: usage message to be written";

FirstErrorIndex::usage = "placeholder: usage message to be written";

Feedback::usage = "placeholder: usage message to be written";
Supplementaries::usage = "placeholder: usage message to be written";

QuestionResponseCell::usage = "placeholder: usage message to be written";
QuestionResponseButton::usage = "placeholder: usage message to be written";

SetValues::usage = "placeholder: usage message to be written";
SetChildValues::usage = "placeholder: usage message to be written";
AskQuestion::usage = "placeholder: usage message to be written";

s::usage = "placeholder: usage message to be written";

Begin["`Private`"]
Clear[s]

SetAttributes[SetValues,HoldAll];
SetAttributes[SetChildValues,HoldAll];
(*Setting the initial values*)
	SetValues[nb_,question_]:=(
	Questions[question][destinationNotebook] = nb;
	Questions[question][currentValues] = ReleaseHold[Questions[question][parameterValues]];
	Questions[question][currentAnswerValue] = Questions[question][answerValue]/.Thread[Questions[question][parameters]->Questions[question][currentValues]];	
	Questions[question][currentErrorValues] = Questions[question[anticipatedErrors]]/.Thread[Questions[question][parameters]->Questions[question][currentValues]];
)
(*Setting child values*)
SetChildValues[nb_,parentQuestion_,childQuestion_]:=(
	Questions[childQuestion][destinationNotebook] = nb;
	Questions[childQuestion][currentValues] = Questions[parentQuestion][currentValues];
	Questions[childQuestion][currentAnswerValue] = Questions[childQuestion][answerValue]/.Thread[Questions[childQuestion][parameters]->Questions[childQuestion][currentValues]];	
	Questions[childQuestion][currentErrorValues] = Questions[childQuestion][anticipatedErrors]/.Thread[Questions[childQuestion][parameters]->Questions[childQuestion][currentValues]];
)
(*Asking a question*)
AskQuestion[question_]:=(
	NotebookWrite[Questions[question][destinationNotebook],Questions[question][questionText]/.Thread[Questions[question][parameters]->Questions[question][currentValues]]];
	NotebookWrite[Questions[question][destinationNotebook],QuestionResponseCell[question]];
	NotebookWrite[Questions[question][destinationNotebook],QuestionResponseButton[question]]
)
(*Check if the input answer is correct*)
Grade[question_,studentAnswer_] := Questions[question][gradingFunction][
	Questions[question][currentAnswerValue],
	If[Questions[question][answerType]=="Expression",ToExpression[studentAnswer],studentAnswer]]

(*Find out if the input answer matches one of the anticipated answers*)
GradeError[question_,studentAnswer_] := Map[
	Questions[question][gradingFunction][#, If[Questions[question][answerType]=="Expression",ToExpression[studentAnswer],studentAnswer]] &, 
    Questions[question][anticipatedErrors] /. Thread[Questions[question][parameters]->Questions[question][currentValues]]]
  
  (*Find what particular anticipated answer was input by the student*)
FirstErrorIndex[question_,studentAnswer_] := Position[GradeError[question,studentAnswer],True]

(*Based on the realized anticipated error choose a feedback*)
Feedback[question_,studentAnswer_]:=Module[{ge=GradeError[question,studentAnswer]},Which[
	Grade[question,studentAnswer],
	Questions[question][correctAnswerFeedback],
	MemberQ[ge,True],
	Questions[question][anticipatedErrorFeedback][[First[Position[ge,True]]]],
	True,
	Questions[question][unanticipatedErrorFeedback]
]/.Thread[Questions[question][parameters]->Questions[question][currentValues]]]

(*based on the realized participated error choose a supplementary hint-question*)
Supplementaries[question_,studentAnswer_]:=If[
	Grade[question,studentAnswer],
	Questions[question][correctAnswerSupplementaries],
	Questions[question][incorrectAnswerSupplementaries]
]
(*response module*)
QuestionResponseCell[question_]:=With[{symbol=Symbol["$CellContext`"<>Questions[question][questionName]<>"StudentAnswer"]},
Cell[BoxData[
 InputFieldBox[Dynamic[symbol], String,
  FieldHint->"Enter your answer"]], "Text"]]

QuestionResponseButton[question_]:=With[{symbol=Symbol["$CellContext`"<>Questions[question][questionName]<>"StudentAnswer"]},
Cell[BoxData[
 ButtonBox["OK",
  Appearance->Automatic,
  ButtonFunction:>((SelectionMove[EvaluationBox[],All,Cell];SelectionMove[Questions[question][destinationNotebook],After,Cell];
    NotebookWrite[Questions[question][destinationNotebook],Feedback[question, symbol]];
    Do[SetChildValues[Questions[question][destinationNotebook],question,supplementary],{supplementary,Supplementaries[question,symbol]}];
    Do[AskQuestion[supplementary],{supplementary,Supplementaries[question,symbol]}])&),
  Evaluator->Automatic,
  Method->"Preemptive"]], "Text"]]
(*Structure of the questions*)
Questions = <|
	question1 -><|
		questionName->"Question1",
		destinationNotebook->Null,
		questionText-> Cell[TextData[{
 "A particle moves a distance of ",
 Cell[BoxData[
  FormBox["s", TraditionalForm]],
  FormatType->TraditionalForm],
 " metres; its speed over the first ",
 Cell[BoxData[
  FormBox[
   RowBox[{"s", "/", "2"}], TraditionalForm]],
  FormatType->TraditionalForm],
 " metres is ",
 Cell[BoxData[
  FormBox[$a, TraditionalForm]],
  FormatType->TraditionalForm],
 " metres per second, and its speed over the second ",
 Cell[BoxData[
  FormBox[
   RowBox[{"s", "/", "2"}], TraditionalForm]],
  FormatType->TraditionalForm],
 " metres is ",
 Cell[BoxData[
  FormBox[$b, TraditionalForm]],
  FormatType->TraditionalForm],
 " metres per second. What its its average speed?"
}], "Text"],
		parameters->{$a,$b},
		parameterValues->{Hold[RandomInteger[{11,20}]],Hold[RandomInteger[{21,30}]]},
		currentValues->{},
		answerValue->2*$a*$b/($a+$b),
		answerType->"Expression",
		currentAnswerValue->Null,
		anticipatedErrors->{($a+$b)/2,Sqrt[$a $b]},
		currentErrorValues->{},	
		gradingFunction->(TrueQ[#1==#2]&),(* we want different grading functions for the correct answer and for each anticipated error*)
		errorIdentificationFunctions->{}, 
		unanticipatedErrorFeedback->Cell["Your answer seems to be incorrect, but we' re not sure what error you made . Try to answer the following questions :", "Text"],
		anticipatedErrorFeedback->{Cell[TextData[{
 "You seem to have taken the mean of the two speeds. But is that right? Did the \
particle spend the same amount of time going at ",
 Cell[BoxData[
  FormBox[$a, TraditionalForm]]],
 " metres per second as at ",
 Cell[BoxData[
  FormBox[$b, TraditionalForm]],
  FormatType->TraditionalForm],
 " metres per second? \n\nTry to answer the following questions:"
}], "Text"],Cell["
You seem to have taken the geometric mean of the two speeds. But is that right? \n\nTry to answer the following questions:", "Text"]},
		correctAnswerFeedback->Cell["Correct, well done!", "Text"],
		incorrectAnswerSupplementaries->{question1Supplementary1},
		correctAnswerSupplementaries->{}
|>,
	
	question1Supplementary2 -> <|
		questionName->"Question1Supplementary2",
		destinationNotebook->Null,
		questionText-> Cell[TextData[{
 "How long does the particle spend travelling at ",
 Cell[BoxData[
  FormBox[$a, TraditionalForm]],
  FormatType->TraditionalForm],
 " metres per second?"
}], "Text"],
		parameters->{$a,$b},
		parameterValues->{},
		currentValues->{},
		answerValue->s/(2*$a),
		answerType->"Expression",
		currentAnswerValue->Null,
		anticipatedErrors->{},
		currentErrorValues->{},	
		gradingFunction->(TrueQ[#1==#2]&),(* we may want different grading functions for the correct answer and for each anticipated error*)
		errorIdentificationFunctions->{}, (* that's what this is a place for *)
		unanticipatedErrorFeedback->Cell["Incorrect.", "Text"],
		anticipatedErrorFeedback->{},
		correctAnswerFeedback->Cell["Correct! Now let's get back to the previous question.", "Text"],
		incorrectAnswerSupplementaries->{},
		correctAnswerSupplementaries->{question1Supplementary1}
	|>,
	question1Supplementary1-> <|
		questionName->"question1Supplementary1",
		destinationNotebook->Null,
		questionText->Cell["Is the amount of time to cover the first half of the way equal to the amount of time to cover the second half?","Text"],
		parameters->{$a,$b},
		parameterValues->{},
		currentValues->{},
		answerValue->"Negative",
		answerType->"String",
		currentAnswerValue->Null,
		anticipatedErrors->{"Positive","Neutral"},
		currentErrorValues->{},
		gradingFunction->(TrueQ[Classify["Sentiment"][#2]==#1]&),
		unanticipatedErrorFeedback->Cell["Incorrect.", "Text"],
		anticipatedErrorFeedback->Cell["Incorrect.", "Text"],
		correctAnswerFeedback->Cell["Correct! Now let's think about the previous question.", "Text"],
		incorrectAnswerSupplementaries->{question1Supplementary2},
		correctAnswerSupplementaries->{question1} |>
|>

End[ ]

EndPackage[ ]
